#!C:/Programs/Strawberry/win64/perl/bin/perl.exe -I"."

##################################
#         Maths  trainer         #
##################################
# Linear equations in 1 variable #
##################################

use strict; use warnings;

use CGI;
use CGI::Carp "fatalsToBrowser";

my $cgi = new CGI;
print "Content-Type: text/html\n\n";
print '<!DOCTYPE html>', "\n\n";
# -------------------------------------------------------------
# Set $app_dir to the full path of the directory,
# where the template file "equations1.template.html" is located
my $app_dir = "C:\\Programs\\Apache24\\htdocs";
# -------------------------------------------------------------
my $questions; my $question;
my $equation = ''; my $solution = ''; my $root = '';
my $usolution; my $uroot;
my $evaluation; my $correct; my $correctanswer;
# Get parameters from 'calling' webpage and determine next button-push action
my %params = $cgi->Vars;
my $action = lc($params{'action'});
$action = 'init' unless ($action);
if ($action eq 'init' or $action eq 'new' or $action eq 'start' or $action eq 'next' or $action eq 'check') {
  my $nextaction;
  if ($action eq 'init' or $action eq 'new') {
    if ($action eq 'init') {
      $questions = 10;
    }
    else {
      $questions = $params{'hquestions'};
    }
    $question = 0;
    $nextaction = 'start';
  }
  else {
    $question = $params{'hquestion'};
    if ($action eq 'start' or $action eq 'next') {
      if ($action eq 'start') {
        $questions = $params{'questions'};
        $correct = 0;
      }
      else {
        $questions = $params{'hquestions'};
        $correct = $params{'hcorrect'};
      }
      $nextaction = 'check';
    }
    elsif ($action eq 'check') {
      $questions = $params{'hquestions'};
      $correct = $params{'hcorrect'};
      if ($question < $questions) {
        $nextaction = 'next';
      }
      else {
        $nextaction = 'new';
      }
    }
  }
  # XSS protection: Potential risk characters removal and variable check!
  $questions =~ s/[^0-9]*//g; $correct =~ s/[^0-9]*//g; $question =~ s/[^0-9]*//g;
  unless ($questions) {
    $questions = 10;
  }
  # Generate equation or check user answer
  if ($action eq 'start' or $action eq 'next') {
    $question++;
    # Generate equation
    ($equation, $solution, $root) = generateEquation();
    $usolution = ''; $uroot = ''; $evaluation = '';
  }
  elsif ($action eq 'check') {
    # Check user answer
    $equation = $params{'hequation'}; $equation =~ s/[^x0-9\.\+\-\=\(\) ]*//g;
    ($solution, $root) = split(/\//, $params{'hsolution'});
    unless ($solution eq 'unique' or $solution eq 'none' or $solution eq 'infinity') {
      $solution = '';
    }
    $root =~ s/[^0-9\.\-]*//g;
    $usolution = $params{'solution'}; $uroot = $params{'root'};
    $uroot =~ s/\,/\./g;                                                       # this allows using the comma as decimal separator
    unless ($usolution eq 'unique' or $usolution eq 'none' or $usolution eq 'infinity') {
      $usolution = '';
    }
    unless ($uroot =~ /^(\d+|\d+\.\d+|-\d+|-\d+\.\d+)$/) {                     # check if solution is decimal number
      $uroot = '';
    }
    $correctanswer = 0;
    if ($usolution and $usolution eq $solution) {
      # Solution type (unique, none, infinity) = correct
      $correctanswer = 1;
      # Check if unique root is correct
      if ($usolution eq 'unique') {
        if ($uroot eq '') {
          $correctanswer = 0
        }
        elsif ($uroot != $root) {
          $correctanswer = 0;
        }
      }
    }
    # User answer evaluation
    if ($correctanswer) {
      # Correct answer
      $evaluation = 'This is correct!';
      $correct++;
    }
    else {
      # False answer (display correct answer)
      $evaluation = 'False! Correct answer is: ' . ucfirst($solution);
      if ($solution eq 'unique') {
        $evaluation .= ' solution x = ' . $root . '.';
      }
      elsif ($solution eq 'none') {
        $evaluation =~ s/none//i;
        $evaluation .= ' No solution.';
      }
      else {
        $evaluation .= ' of solutions.'
      }
    }
  }
  # Read template HTML file
  my $template = "$app_dir\\equations1.template.html";
  open(my $input, "<", $template)
    or die "Can't open template file $template: $!";
  my @lines = <$input>;
  close($input);
  # Create the webpage
  foreach my $line (@lines) {
    chomp($line);
    if ($line) {
      if (substr($line, 0, 1) eq '#') {                                        # a '#' at beginning of line indicates that line contains a tag
        $line = substr($line, 1);
        if ($line =~ /#questions#/) {
          $line =~ s/#questions#/$questions/;
          if ($action eq 'init' or $action eq 'new') {
            $line =~ s/#readonly#//;
          }
          else {
            $line =~ s/#readonly#/readonly="readonly"/;                        # disable modification of test-questions number during test
          }
        }
        elsif ($line =~ /#equationcount#/) {
          if ($action eq 'init' or $action eq 'new') {
            $line =~ s/#equationcount#/Equation/;
          }
          else {
          $line =~ s/#equationcount#/Equation $question\/$questions/;          #  display actual question number
          }
          $line =~ s/#equation#/$equation/;
        }
        elsif ($line =~ /#checked1#/) {
          if ($usolution eq 'unique') {
            $line =~ s/#checked1#/checked="checked"/;                          # check 'unique solution' radiobutton
          }
          else {
            $line =~ s/#checked1#//;
          }
          $line =~ s/#root#/$uroot/;                                           # display root (or nothing)
        }
        elsif ($line =~ /#checkedno#/) {
          if ($usolution eq 'none') {
            $line =~ s/#checkedno#/checked="checked"/;                         # check 'no solution' radiobutton
          }
          else {
            $line =~ s/#checkedno#//;
          }
        }
        elsif ($line =~ /#checkedinf#/) {
          if ($usolution eq 'infinity') {
            $line =~ s/#checkedinf#/checked="checked"/;                        # check 'infinity of solutions' radiobutton
          }
          else {
            $line =~ s/#checkedinf#//;
          }
        }
        elsif ($line =~ /#eval#/) {
          if ($evaluation) {
            $line =~ s/#eval#/$evaluation/;
            if ($correctanswer) {
              $line =~ s/#class#/class="bold"/;                                # display evaluation in black bold, if correct answer
            }
            else {
              $line =~ s/#class#/class="red"/;                                 # display evaluation in red bold, if false answer
            }
          }
          else {
            $line =~ s/#eval#/&nbsp;/;                                         # no evaluation displayed (case if question is asked)
            $line =~ s/ #class#//;
          }
        }
        elsif ($line =~ /#button#/) {
          my $button = ucfirst($nextaction);
          $line =~ s/#button#/$button/;                                        # set button caption to next action
        }
        elsif ($line =~ /#table#/) {
          # Display test evaluation table (at end of test)
          if ($nextaction eq 'new' and $questions >= 5) {                      # evaluate only, if there were at least 5 questions
            my $false = $questions - $correct;
            my $success = 100 * ($correct / $questions); $success = int($success + 0.5);
            # Use spaces (&nbsp;) to right-align the count values
            my $tquestions = sprintf("%4u", $questions); $tquestions =~ s/ /&nbsp; /g;
            my $tcorrect = sprintf("%4u", $correct); $tcorrect =~ s/ /&nbsp; /g;
            $false = sprintf("%4u", $false); $false =~ s/ /&nbsp; /g;
            $success = sprintf("%3u", $success); $success =~ s/ /&nbsp; /g;
            # Create table HTML
            my $table = '<table border="1" style="padding:5px">';
            $table .= '<tr><th colspan="2" align="center" style="padding:5px">Evaluation</td></tr>';
            $table .= '<tr><td style="padding:5px">Questions</td><td style="padding:5px">' . $tquestions . '</td></tr>';
            $table .= '<tr><td style="padding:5px">Correct</td><td style="padding:5px">' . $tcorrect . '</td></tr>';
            $table .= '<tr><td style="padding:5px">False</td><td style="padding:5px">' . $false . '</td></tr>';
            $table .= '<tr><td style="padding:5px">Success</td><td style="padding:5px">' . $success . '%</td></tr>';
            $table .= '</table>';
            $line =~ s/#table#/$table/;
          }
          # Displaay nothing if test not yet done
          else {
            $line =~ s/#table#/&nbsp;/;
          }
        }
        elsif ($line =~ /#hquestions#/) {
          $line =~ s/#hquestions#/$questions/;                                 # save test-questions number to hidden field
        }
        elsif ($line =~ /#hquestion#/) {
          $line =~ s/#hquestion#/$question/;                                   # save actual question number to hidden field
        }
        elsif ($line =~ /#hequation#/) {
          $line =~ s/#hequation#/$equation/;                                   # save equation string to hidden field
        }
        elsif ($line =~ /#hsolution#/) {
          $line =~ s/#hsolution#/$solution\/$root/;                            # save actual solution to hidden field
        }
        elsif ($line =~ /#hcorrect#/) {
          $line =~ s/#hcorrect#/$correct/;                                     # save number of correct answers to hidden field
        }
      }
    }
    # Print file-line (with tags replaced) to webpage
    unless ($line =~ /#/) {
      print "$line\n";
    }
  }
}

# --------------------------------------
# Generate linear equation in 1 variable
# --------------------------------------

sub generateEquation {
  my ($equation, $solution, $root);
  my $X1; my $X2; my $C1; my $C2; my $M;
  my $solutions = int(rand(10)) + 1;                                           # 1/10 'no solution', 1/10 'infinity of solutions', 8/10 'unique solution'
  my $ok = 0;
  do {
    my $type = int(rand(2));
    if ($type == 0) {                                                          # equation type: a1x + b1 = a2x + b2
      $M = 1
    }
    else {
      $M = int(rand(11)) - 5;                                                  # equation type: m(a1x + b1) = a2x + b2
    }
    $M = 1 if $M == 0;
    # Generate random values until they are 'ok'. In particular until
    # result is an integer or undefined. Also eliminate equations like
    # '0x = a2x + b2' and 'a1x = b1x'
    my $X0; my $C0;
    do {
      $X1 = int(rand(21)) - 10; $X2 = int(rand(21)) - 10;                      # all coefficients between -10 and 10
      $C1 = int(rand(21)) - 10; $C2 = int(rand(21)) - 10;
      if ($C1 == 0 or $X1 == 0) {                                              # eliminate m*ax and m*c
        $M = 1;
      }
      $X0 = $M * $X1 - $X2; $C0 = $C2 - $M * $C1;                              # grouping of x-coefficients and constants
    }
    while (!(($X0 == 0 or ($C0 / $X0) == int($C0 / $X0)) and (($X1 != 0) and ($C1 != 0 or $C2 != 0 or $X2 == 0))));
    # Determine equation solution(s)
    if ($X0 == 0) {
      if ($C0 == 0) {
        $solution = 'infinity';
      }
      else {
        $solution = 'none';
      }
    }
    else {
      $solution = 'unique';
      $root = $C0 / $X0;
    }
    # Check if equation solution corresponds to the actual type (unique, none, infinity)
    # If not, repeat the generation loop...
    if ($solutions == 1 and $solution eq 'none') {
      $ok = 1;
    }
    elsif ($solutions == 10 and $solution eq 'infinity') {
      $ok = 1;
    }
    elsif ($solutions != 1 and $solutions != 10 and $solution eq 'unique') {
      $ok = 1;
    }
  }
  while (!$ok);
  # Create equation string
  $equation = '';
  if ($M == -1) {                                                              # pretty display...
    $equation = '-(';
  }
  elsif ($M != 1) {
    $equation = $M . '(';
  }
  $equation .= formatEquation($X1, $C1);                                       # and even prettier...
  if ($M != 1) {
    $equation = $equation . ')';
  }
  $equation .= ' = ' . formatEquation($X2, $C2);
  return($equation, $solution, $root);
}

# ---------------------------------------
# Format equation string (pretty display)
# ---------------------------------------

sub formatEquation {

  my ($X, $C) = @_;
  my $equation = '';
  if ($X == 0) {                                                               # print '0' instead of '0x'
    if ($C == 0) {
      $equation = '0';
    }
    else {
      $equation = $C;
    }
  }
  else {
    if ($X == 1) {                                                             # print 'x' instead of '1x'
      $equation = 'x';
    }
    elsif ($X == -1) {                                                         # print '-x' instead of '-1x'
      $equation = '-x';
    }
    elsif ($X != 0) {
      $equation = $X . 'x';
    }
    if ($C > 0) {                                                              # pretty display for +/-/0 constant
      $equation .= ' + ' . $C;
    }
    elsif ($C < 0) {
      $equation .= ' - ' . abs($C);
    }
  }
  return($equation);

}
